## ros-foxy-mapviz 2.2.1

=== CMakeLists.txt ===
### SET CMAKE POLICIES ###
cmake_minimum_required(VERSION 3.10...3.17)

if(${CMAKE_VERSION} VERSION_LESS 3.12)
    cmake_policy(VERSION ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION})
endif()

if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(${CMAKE_VERSION} VERSION_EQUAL "3.11.0" OR ${CMAKE_VERSION} VERSION_GREATER "3.11.0")
  cmake_policy(SET CMP0072 NEW)
endif()

if (CMAKE_COMPILER_IS_GNUCXX OR CMAKE_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()
### END CMAKE POLICIES ###

project(mapviz 
  DESCRIPTION "Mapviz is a ROS based visualization tool with a plug-in system similar to RVIZ focused on visualizing 2D data."
  LANGUAGES CXX)

### ROS Packages ###
find_package(ament_cmake REQUIRED)
find_package(cv_bridge REQUIRED)
find_package(geometry_msgs REQUIRED)
find_package(image_transport REQUIRED)
find_package(mapviz_interfaces REQUIRED)
find_package(marti_common_msgs REQUIRED)
find_package(pluginlib REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rqt_gui_cpp REQUIRED)
find_package(std_srvs REQUIRED)
find_package(swri_math_util REQUIRED)
find_package(swri_transform_util REQUIRED)
find_package(tf2 REQUIRED)
find_package(tf2_ros REQUIRED)

# tf2_geometry_msgs 0.12.1 broke API compatibility, so check which version
# we need to use
find_package(tf2_geometry_msgs REQUIRED)
if("${tf2_geometry_msgs_VERSION}" VERSION_GREATER "0.12.0")
  set(USE_NEW_TF2_TOMSG 1)
else()
  set(USE_NEW_TF2_TOMSG 0)
endif()

### PkgConfig ###
find_package(PkgConfig REQUIRED)
pkg_check_modules(YamlCpp yaml-cpp)

### Boost ###
find_package(Boost REQUIRED date_time system filesystem)

### OpenCV 3/4 on ROS2 ###
find_package(OpenCV COMPONENTS core imgproc imgcodecs videoio REQUIRED)

# ### Qt5 on ROS2 ###
find_package(Qt5Concurrent REQUIRED)
find_package(Qt5Core REQUIRED)
find_package(Qt5Gui REQUIRED)
find_package(Qt5OpenGL REQUIRED)
find_package(Qt5Widgets REQUIRED)
add_definitions(-DWFlags=WindowFlags)
set(QT_USE_QTOPENGL TRUE)

### OpenGL ###
find_package(OpenGL REQUIRED)
find_package(GLUT REQUIRED)

### GLEW ###
find_package(GLEW REQUIRED)

# Fix conflict between Boost signals used by tf and QT signals used by mapviz
add_definitions(-DQT_NO_KEYWORDS)

# Need to include the current dir to include the results of building Qt UI files
set(CMAKE_INCLUDE_CURRENT_DIR ON)

# Qt UI files
set(UI_FILES
  src/configitem.ui
  src/${PROJECT_NAME}.ui
  src/pluginselect.ui
)
# Headers containing QObject definitions
set(QT_HEADERS
  include/${PROJECT_NAME}/color_button.h
  include/${PROJECT_NAME}/config_item.h
  include/${PROJECT_NAME}/map_canvas.h
  include/${PROJECT_NAME}/${PROJECT_NAME}.hpp
  include/${PROJECT_NAME}/${PROJECT_NAME}_plugin.h
  include/${PROJECT_NAME}/rqt_${PROJECT_NAME}.h
  include/${PROJECT_NAME}/select_frame_dialog.h
  include/${PROJECT_NAME}/select_service_dialog.h
  include/${PROJECT_NAME}/select_topic_dialog.h
  include/${PROJECT_NAME}/video_writer.h
  include/${PROJECT_NAME}/widgets.h
)
# Source files for mapviz
set(SRC_FILES
  src/${PROJECT_NAME}.cpp
  src/color_button.cpp
  src/config_item.cpp
  src/${PROJECT_NAME}_application.cpp
  src/map_canvas.cpp
  src/rqt_${PROJECT_NAME}.cpp
  src/select_frame_dialog.cpp
  src/select_service_dialog.cpp
  src/select_topic_dialog.cpp
  src/video_writer.cpp
)

### Qt5 on ROS2 ###
qt5_add_resources(RCC_SRCS src/resources/icons.qrc)
qt5_wrap_ui(SRC_FILES ${UI_FILES})
qt5_wrap_cpp(SRC_FILES ${QT_HEADERS})

### Build mapviz as an rqt plugin ###
add_library(rqt_${PROJECT_NAME}
  ${SRC_FILES}
  ${RCC_SRCS}
)
target_include_directories(rqt_${PROJECT_NAME} 
  PUBLIC
    include
  PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR})
target_compile_definitions(rqt_${PROJECT_NAME}
  PRIVATE
    USE_NEW_TF2_TOMSG=${USE_NEW_TF2_TOMSG}
)
target_link_libraries(rqt_${PROJECT_NAME}
  OpenGL::GL
  ${GLUT_LIBRARY}
  GLEW::GLEW
  opencv_core
  opencv_highgui
  opencv_imgproc
  opencv_imgcodecs
  opencv_videoio
  ${YamlCpp_LIBRARIES}
  Qt5::Concurrent
  Qt5::Core
  Qt5::Gui
  Qt5::OpenGL
  Qt5::Widgets
)
ament_target_dependencies(rqt_${PROJECT_NAME}
  ament_cmake
  cv_bridge
  geometry_msgs
  image_transport
  mapviz_interfaces
  marti_common_msgs
  pluginlib
  rclcpp
  rqt_gui_cpp
  std_srvs
  swri_math_util
  swri_transform_util
  tf2
  tf2_geometry_msgs
  tf2_ros
)
set_target_properties(rqt_${PROJECT_NAME} PROPERTIES
  COMPILE_FLAGS "-D__STDC_FORMAT_MACROS"
)

### Build mapviz as a standalone executable ###
add_executable(${PROJECT_NAME}
  src/${PROJECT_NAME}_main.cpp
)
target_link_libraries(${PROJECT_NAME}
  rqt_${PROJECT_NAME}
  ${Boost_LIBRARIES}
  ${GLU_LIBRARY}
)
ament_target_dependencies(${PROJECT_NAME}
  swri_math_util
  swri_transform_util
)
set_target_properties(${PROJECT_NAME} PROPERTIES
  COMPILE_FLAGS "-D__STDC_FORMAT_MACROS"
)

### Install mapviz ###
install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION include/${PROJECT_NAME}
  FILES_MATCHING PATTERN "*.h"
)

install(TARGETS ${PROJECT_NAME} rqt_${PROJECT_NAME}
  RUNTIME DESTINATION lib/${PROJECT_NAME}
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
)

install(DIRECTORY launch
  DESTINATION share/${PROJECT_NAME}
)

install(FILES plugin.xml
  DESTINATION share/${PROJECT_NAME} 
)

ament_export_dependencies(${RUNTIME_DEPS}
  Qt5Concurrent
  Qt5Core
  Qt5Gui
  Qt5OpenGL
  Qt5Widgets
)
ament_export_include_directories(include)
ament_export_libraries(rqt_${PROJECT_NAME} ${YamlCpp_LIBRARIES})
ament_package()

=== debian/changelog ===
ros-foxy-mapviz (2.2.1-1focal) focal; urgency=high

  * Updating maintainers list (#778 <https://github.com/swri-robotics/mapviz/issues/778>)
  * Contributors: David Anthony

 -- Southwest Research Institute <swri-robotics@swri.org>  Tue, 30 May 2023 05:00:00 -0000

ros-foxy-mapviz (2.1.0-1focal) focal; urgency=high

  * ROS Foxy support (#695 <https://github.com/swri-robotics/mapviz/issues/695>)
  * Contributors: P. J. Reed

 -- P. J. Reed <preed@swri.org>  Thu, 22 Oct 2020 05:00:00 -0000

ros-foxy-mapviz (2.0.0-1focal) focal; urgency=high

  * Port mapviz to ROS 2 (#672 <https://github.com/swri-robotics/mapviz/issues/672>)
  * Remove OpenGL warning (#667 <https://github.com/swri-robotics/mapviz/issues/667>)
  * Resolves segfault issue on ClearHistory() function call (#651 <https://github.com/swri-robotics/mapviz/issues/651>)
  * Fix plug-in config panel to scroll per-pixel instead of per-item, allowing configuration of plug-ins that have config settings that are too large to fit in the panel all at once. (#646 <https://github.com/swri-robotics/mapviz/issues/646>)
  * Contributors: Daniel D'Souza, Marc Alban, Matthew Bries, Matthew Grogan, P. J. Reed, Jason Gassaway, John Reyes, Jacob Hassold, Kevin Nickels, Roger Strain

 -- P. J. Reed <preed@swri.org>  Wed, 13 May 2020 05:00:00 -0000

ros-foxy-mapviz (1.2.0-1focal) focal; urgency=high



 -- P. J. Reed <preed@swri.org>  Wed, 04 Sep 2019 05:00:00 -0000

ros-foxy-mapviz (1.1.1-1focal) focal; urgency=high

  * Set main window as in focus on start #630 <https://github.com/swri-robotics/mapviz/issues/630>
  * Specify default configuration extension on save
  * Contributors: Daniel D'Souza, mattrich37, mrichardson

 -- P. J. Reed <preed@swri.org>  Fri, 17 May 2019 05:00:00 -0000

ros-foxy-mapviz (1.1.0-1focal) focal; urgency=high



 -- P. J. Reed <preed@swri.org>  Wed, 20 Feb 2019 06:00:00 -0000

ros-foxy-mapviz (1.0.1-1focal) focal; urgency=high



 -- P. J. Reed <preed@swri.org>  Fri, 25 Jan 2019 06:00:00 -0000

ros-foxy-mapviz (1.0.0-1focal) focal; urgency=high

  * Sharing tf_manager_ between main app and plugins (#555 <https://github.com/swri-robotics/mapviz/issues/555>)
  * Contributors: Davide Faconti

 -- P. J. Reed <preed@swri.org>  Wed, 23 Jan 2019 06:00:00 -0000

ros-foxy-mapviz (0.3.0-1focal) focal; urgency=high

  * Merge all -devel branches into a single master branch
  * Add function to lock canvas movement (#596 <https://github.com/swri-robotics/mapviz/issues/596>)
  * Contributors: P. J. Reed

 -- P. J. Reed <preed@swri.org>  Fri, 16 Nov 2018 06:00:00 -0000

ros-foxy-mapviz (0.2.6-1focal) focal; urgency=high



 -- P. J. Reed <preed@swri.org>  Tue, 31 Jul 2018 05:00:00 -0000

ros-foxy-mapviz (0.2.5-1focal) focal; urgency=high

  * Add clear history functionality.
  * New plugin to send commands to move_base
  * improve text contrast (#550 <https://github.com/swri-robotics/mapviz/issues/550>)
  * Glew warning fixed (#539 <https://github.com/swri-robotics/mapviz/issues/539>)
  * remove copy and paste of Print...
  * add context menu to config_item (#526 <https://github.com/swri-robotics/mapviz/issues/526>)
  * Merge pull request #523 <https://github.com/swri-robotics/mapviz/issues/523> from matt-attack/add-keyboard-input-support-kinetic
  * Add keyboard input support for plugins
  * update to use non deprecated pluginlib macro
  * Fix the "File" menu actions (#513 <https://github.com/swri-robotics/mapviz/issues/513>)
  * Merge pull request #481 <https://github.com/swri-robotics/mapviz/issues/481> from pjreed/threaded-video-recording-kinetic
  * Move video recording into its own thread
  * Contributors: Davide Faconti, Marc Alban, Matthew Bries, Mikael Arguedas, P. J. Reed

 -- P. J. Reed <preed@swri.org>  Thu, 12 Apr 2018 05:00:00 -0000

ros-foxy-mapviz (0.2.4-1focal) focal; urgency=high

  * Add basic profiling to mapviz.
  * Handle GL canvas transforms with an invalid target frame
  * Add parameter to disable auto-saving functionality.
  * Contributors: Elliot Johnson, Marc Alban, P. J. Reed

 -- P. J. Reed <preed@swri.org>  Fri, 11 Aug 2017 05:00:00 -0000

ros-foxy-mapviz (0.2.3-1focal) focal; urgency=high

  * Fix mapviz kinetic build. (#456 <https://github.com/evenator/mapviz/issues/456>)
    Add a missing rosdep dependency on libxi-dev.
  * Contributors: Edward Venator

 -- P. J. Reed <preed@swri.org>  Sat, 10 Dec 2016 06:00:00 -0000

ros-foxy-mapviz (0.2.2-1focal) focal; urgency=high

  * Migrated OpenCV to 3.1 (default in Kinetic)
  * Contributors: Brian Holt

 -- P. J. Reed <preed@swri.org>  Wed, 07 Dec 2016 06:00:00 -0000

ros-foxy-mapviz (0.2.1-1focal) focal; urgency=high

  * Add a GUI for controlling the Image Transport (#432 <https://github.com/swri-robotics/mapviz/issues/432>)
    This will add a sub-menu under the "View" menu that will:
    - List all available image transports
    - Indicate which one is currently the default
    - Allow the user to choose which one will be used for new ImageTransport subscriptions
    - Save and restore this setting to Mapviz's config file
    - Cause any image plugins using the default transport to resubscribe
    In addition, the image plugin now has a menu that can be used to change the
    transport for that specific plugin so that it is different from the default.
    Fixes #430 <https://github.com/swri-robotics/mapviz/issues/430>
    Conflicts:
    mapviz/package.xml
  * Fix icon colors for point drawing plugins (#433 <https://github.com/swri-robotics/mapviz/issues/433>)
    This was probably broken back when all of these were refactored to have a
    single base class.  It looks like the member variable that holds the color
    used to draw the icon was never actually being updated.
    Fixes #426 <https://github.com/swri-robotics/mapviz/issues/426>
  * Remove unnecessary include
  * Fix warnings in mapviz.
    Fix several reorder and signed comparison warnings in the mapviz
    package.
  * Giving tile_map an interface overhaul


=== debian/control ===
Source: ros-foxy-mapviz
Section: misc
Priority: optional
Maintainer: Southwest Research Institute <swri-robotics@swri.org>
Build-Depends: debhelper (>= 9.0.0), freeglut3-dev, libglew-dev, libqt5core5a, libqt5opengl5-dev, libxi-dev, libxmu-dev, libyaml-cpp-dev, pkg-config, qt5-qmake, ros-foxy-ament-cmake, ros-foxy-cv-bridge, ros-foxy-geometry-msgs, ros-foxy-image-transport, ros-foxy-mapviz-interfaces, ros-foxy-marti-common-msgs, ros-foxy-pluginlib, ros-foxy-rclcpp, ros-foxy-rqt-gui, ros-foxy-rqt-gui-cpp, ros-foxy-std-srvs, ros-foxy-swri-math-util, ros-foxy-swri-transform-util, ros-foxy-tf2, ros-foxy-tf2-geometry-msgs, ros-foxy-tf2-ros, ros-foxy-ros-workspace
Homepage: https://github.com/swri-robotics/mapviz
Standards-Version: 3.9.2

Package: ros-foxy-mapviz
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, freeglut3-dev, libglew-dev, libqt5core5a, libqt5opengl5, libxi-dev, libxmu-dev, libyaml-cpp-dev, ros-foxy-cv-bridge, ros-foxy-geometry-msgs, ros-foxy-image-transport, ros-foxy-launch-xml, ros-foxy-mapviz-interfaces, ros-foxy-marti-common-msgs, ros-foxy-pluginlib, ros-foxy-rclcpp, ros-foxy-rqt-gui, ros-foxy-rqt-gui-cpp, ros-foxy-std-srvs, ros-foxy-swri-math-util, ros-foxy-swri-transform-util, ros-foxy-tf2, ros-foxy-tf2-geometry-msgs, ros-foxy-tf2-ros, ros-foxy-ros-workspace
Description: mapviz

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DAMENT_PREFIX_PATH="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-mapviz//opt/ros/foxy/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
